use btleplug::platform::PeripheralId;
use serde::Serialize;

use crate::playlist::PlayMode;

#[derive(Debug, Clone, Default, Serialize)]
pub struct CentralState {
    pub is_ready: bool,
    pub is_scanning: bool,
    pub connected: Option<PeripheralId>,
}

#[derive(Debug, Clone, Serialize)]
pub struct PeripheralItem {
    pub id: PeripheralId,
    pub address: String,
    pub represent: String,
    pub is_connected: bool,
    pub rssi: Option<i16>,
    pub battery: Option<i16>,
}

#[derive(Debug, Clone, Default, Serialize)]
pub struct ChannelState {
    pub is_playing: bool,
    pub strength: u32,
    pub strength_limit: u32,
    pub is_boosting: bool,
    pub boost_level: u32,
    pub boost_limit: u32,
    pub play_mode: PlayMode,
}

#[derive(Debug, Clone, Serialize)]
pub struct ApplicationState {
    pub central: CentralState,
    pub peripherals: Vec<PeripheralItem>,
    pub connected_peripheral: Option<PeripheralItem>,
    pub channel_a: ChannelState,
    pub channel_b: ChannelState,
}
